@
@ Flash Linux Loader for Armonie
@
@ Julien Pilet, 2.2003
@

#include "utils.S"

.text
.global AppMain
AppMain:

	ldr r3, =WelcomeMessage
	bl SendString

	ldr r3, =RevisionMessageStart
	bl SendString

	ldr r0, Revision
	bl SendASCIIWord

	ldr r3, =RevisionMessageEnd
	bl SendString

	ldr r3, =LoadMessage
	bl SendString
	@ copy zImage to SDRAM at address a1000000
	ldr r0, =_binary_zImage_gz_start
	mov r1, #0xa1000000
	ldr r2, =_binary_zImage_gz_end
	add r2, r2, #4
1:
	ldr r3, [r0], #4
	str r3, [r1], #4
	cmp r0, r2
	ble 1b

	ldr r3, =BootMessage
	bl SendString

	@ get ready to call zImage
	bl GetMachineId		@ Get the machine identifier in r1
	mov r0, #0
	mov pc, #0xa1000000

#include "revision.S"

.align	4
WelcomeMessage:
	.ascii	"\r\nFlaBoot - Minimal Flash Booter\r\n"
	.ascii	"(c) 2002 - 2004 Stephane Magnenat & Julien Pilet\r\n"
	.asciz	"This program is GPL\r\n\r\n"

.align	4
LoadMessage:
	.asciz	"Now loading...\r\n"

.align 4
BootMessage:
	.asciz	"Now booting...\r\n"
